---
title: Body.blob()
slug: Web/API/Body/blob
tags:
  - API
  - BODY
  - Blob
  - Experimental
  - Fetch
  - Method
  - Reference
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>blob()</code></strong> method of the {{domxref("Body")}} mixin takes a {{domxref("Response")}} stream and reads it to completion. It returns a promise that resolves with a {{domxref("Blob")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>response</em>.blob().then(function(<em>myBlob</em>) {
  // do something with myBlob
});</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<div class="note"><strong>Note:</strong> If the {{domxref("Response")}} has a {{domxref("Response.type")}} of <code>"opaque"</code>, the resulting {{domxref("Blob")}} will have a {{domxref("Blob.size")}} of <code>0</code> and a {{domxref("Blob.type")}} of empty string <code>""</code>, which renders it <em>useless</em> for methods like {{domxref("URL.createObjectURL")}}.</div>

<h3 id="Return_value">Return value</h3>

<p>A promise that resolves with a {{domxref("Blob")}}.</p>

<h2 id="Example">Example</h2>

<p>In our <a href="https://github.com/mdn/fetch-examples/tree/master/fetch-request">fetch request example</a> (run <a href="https://mdn.github.io/fetch-examples/fetch-request/">fetch request live</a>), we create a new request using the {{domxref("Request.Request","Request()")}} constructor, then use it to fetch a JPG. When the fetch is successful, we read a {{domxref("Blob")}} out of the response using <code>blob()</code>, put it into an object URL using {{domxref("URL.createObjectURL")}}, and then set that URL as the source of an {{htmlelement("img")}} element to display the image.</p>

<pre class="brush: js">var myImage = document.querySelector('img');

var myRequest = new Request('flowers.jpg');

fetch(myRequest)
.then(response =&gt; response.blob())
.then(function(myBlob) {
  var objectURL = URL.createObjectURL(myBlob);
  myImage.src = objectURL;
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-body-blob','blob()')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Body.blob")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
